// inidoc.h : interface of the CIniDoc class
//
/////////////////////////////////////////////////////////////////////////////

class CIniDoc : public CDocument
{
protected: // create from serialization only
	CIniDoc();
	DECLARE_DYNCREATE(CIniDoc)
public:
	enum TestFlags {TEST_GETALL, TEST_WRITE_SHORTER, TEST_WRITE_LONGER};
	
// Attributes
	int GetConvertTime () const {return m_wSecsToConvert;};
	int GetIniLongerTime() const {return m_wSecsIniLonger;};
	int GetIniShorterTime() const {return m_wSecsIniShorter;};
	int GetIniGetAllTime() const {return m_wSecsIniGetAll;};
	int GetCFLongerTime() const {return m_wSecsCFLonger;};
	int GetCFShorterTime() const {return m_wSecsCFShorter;};
	int GetCFGetAllTime() const {return m_wSecsCFGetAll;};
	
	CString GetTestIniFilename () const {return m_aTestASCIIIniFile;}
	CString GetTestCompFilename () const {return m_aTestCompIniFile;} 
	
public:
// Operations
	void DoTimeTest (TestFlags tyTest); // Run a timing test.
	void GetEntries(const char* pszSection, CStringArray& rgEntries,
		CStringArray& rgValues, BOOL bGetFromCFFile);
	void GetSections(CStringArray& rgNamesRet);
	
public:

// Implementation
public:
	virtual ~CIniDoc();
	virtual void Serialize(CArchive& ar);   // overridden for document i/o
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:
	void CreateTestFiles(CArchive& ar);
	void InitMembers (); // Initialize member variables.
	virtual BOOL OnNewDocument();

	CString m_aTestASCIIIniFile;
	CString m_aTestCompIniFile;
	int m_wSecsToConvert; // Time to convert ini to compound file.
	int m_wSecsIniLonger; // Make INI entries longer.
	int m_wSecsIniShorter; // Make shorter.
	int m_wSecsIniGetAll;  // Get all entries.
	int m_wSecsCFLonger;   // Make CF entries longer.
	int m_wSecsCFShorter;  // Make shorter.
	int m_wSecsCFGetAll;   // Get all entries.
	
// Generated message map functions
protected:
	//{{AFX_MSG(CIniDoc)
		// NOTE - the ClassWizard will add and remove member functions here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////
