// iniview.cpp : implementation of the CIniView class
//

#include "stdafx.h"
#include "ini.h"

#include "inidoc.h"
#include "iniview.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CIniView

IMPLEMENT_DYNCREATE(CIniView, CFormView)

BEGIN_MESSAGE_MAP(CIniView, CFormView)
	//{{AFX_MSG_MAP(CIniView)
	ON_LBN_SELCHANGE(IDC_SECTIONS, OnSelchangeSections)
	ON_BN_CLICKED(IDC_GET_ENTRIES, OnGetEntries)
	ON_BN_CLICKED(IDC_WRITE_SHORTER, OnWriteShorter)
	ON_BN_CLICKED(IDC_WRITE_LONGER, OnWriteLonger)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CIniView construction/destruction

CIniView::CIniView()
	: CFormView(CIniView::IDD)
{
	//{{AFX_DATA_INIT(CIniView)
	m_strConvTime = "";
	m_strTestIniFile = "";
	m_strTestCompFile = "";
	m_strIniLongerTime = "";
	m_strIniShorterTime = "";
	m_strIniGetAllTime = "";
	m_strCFLongerTime = "";
	m_strCFShorterTime = "";
	m_strCFGetAllTime = "";
	//}}AFX_DATA_INIT
	// TODO: add construction code here
}

CIniView::~CIniView()
{
}

void CIniView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CIniView)
	DDX_Text(pDX, IDC_CONV_TIME, m_strConvTime);
	DDV_MaxChars(pDX, m_strConvTime, 10);
	DDX_Text(pDX, IDC_TEST_INI_FILE, m_strTestIniFile);
	DDV_MaxChars(pDX, m_strTestIniFile, 256);
	DDX_Text(pDX, IDC_TEST_COMP_FILE, m_strTestCompFile);
	DDV_MaxChars(pDX, m_strTestCompFile, 256);
	DDX_Text(pDX, IDC_INI_MAKE_LONGER, m_strIniLongerTime);
	DDV_MaxChars(pDX, m_strIniLongerTime, 10);
	DDX_Text(pDX, IDC_INI_MAKE_SHORTER, m_strIniShorterTime);
	DDV_MaxChars(pDX, m_strIniShorterTime, 10);
	DDX_Text(pDX, IDC_INI_GET_ALL, m_strIniGetAllTime);
	DDV_MaxChars(pDX, m_strIniGetAllTime, 10);
	DDX_Text(pDX, IDC_CF_MAKE_LONGER, m_strCFLongerTime);
	DDV_MaxChars(pDX, m_strCFLongerTime, 10);
	DDX_Text(pDX, IDC_CF_MAKE_SHORTER, m_strCFShorterTime);
	DDV_MaxChars(pDX, m_strCFShorterTime, 10);
	DDX_Text(pDX, IDC_CF_GET_ALL, m_strCFGetAllTime);
	DDV_MaxChars(pDX, m_strCFGetAllTime, 10);
	//}}AFX_DATA_MAP
	
	// Fill the sections list.
	CListBox * pLB = (CListBox*)GetDlgItem(IDC_SECTIONS);
	CString aName;
	pLB->ResetContent();
	for(int iElem = 0; iElem < m_rgSections.GetSize(); iElem++)
	{
		aName = m_rgSections.GetAt(iElem);
		pLB->AddString(aName);
	}
	
	// The number of sections
	char szNum[5];
	sprintf(szNum, "%d", m_rgSections.GetSize());
	CStatic * pLabel = (CStatic*)GetDlgItem(IDC_NUM_SECTIONS);
	pLabel->SetWindowText(szNum);
	
	// Empty contents of entries list.
	pLB = (CListBox*)GetDlgItem(IDC_ENTRIES);
	pLB->ResetContent();
}

/////////////////////////////////////////////////////////////////////////////
// CIniView diagnostics

#ifdef _DEBUG
void CIniView::AssertValid() const
{
	CFormView::AssertValid();
}

void CIniView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}

CIniDoc* CIniView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CIniDoc)));
	return (CIniDoc*)m_pDocument;
}
#endif //_DEBUG


void CIniView::OnUpdate (CView* pSender, LPARAM lHint, CObject* pHint)
{
	CIniDoc* pDoc = GetDocument ();
	
	m_strTestIniFile = pDoc->GetTestIniFilename();
	m_strTestCompFile = pDoc->GetTestCompFilename();
	
	char szTime[17];
	
	sprintf(szTime, "%d", pDoc->GetConvertTime());
	m_strConvTime = szTime;
	
	sprintf(szTime, "%d", pDoc->GetIniLongerTime());
	m_strIniLongerTime = szTime;

	sprintf(szTime, "%d", pDoc->GetIniShorterTime());
	m_strIniShorterTime = szTime;
	
	sprintf(szTime, "%d", pDoc->GetIniGetAllTime());
	m_strIniGetAllTime = szTime;
	
	sprintf(szTime, "%d", pDoc->GetCFLongerTime());
	m_strCFLongerTime = szTime;
	
	sprintf(szTime, "%d", pDoc->GetCFShorterTime());
	m_strCFShorterTime = szTime;
	
	sprintf(szTime, "%d", pDoc->GetCFGetAllTime());
	m_strCFGetAllTime = szTime;

	pDoc->GetSections (m_rgSections);

	UpdateData(FALSE);
}


/////////////////////////////////////////////////////////////////////////////
// CIniView message handlers

void CIniView::OnSelchangeSections()
{
	// Fill the entries list box with the entries for the selected section.
	CString aSection;
	CString aName;
	CListBox * pLB = (CListBox*)GetDlgItem(IDC_SECTIONS);
	CIniDoc* pDoc = GetDocument ();
	
	int iCurSel = pLB->GetCurSel ();
	if (iCurSel != LB_ERR)
	{
		pLB->GetText(iCurSel, aSection);
		pDoc->GetEntries (aSection, m_rgEntries, m_rgValues, TRUE);
		
		pLB = (CListBox*)GetDlgItem(IDC_ENTRIES);

		pLB->ResetContent();
		for(int iElem = 0; iElem < m_rgEntries.GetSize(); iElem++)
		{
			aName = m_rgEntries.GetAt(iElem);
			aName = aName + "=" + m_rgValues.GetAt(iElem);
			pLB->AddString(aName);
		}

	}
}

void CIniView::OnGetEntries()
{
	// Get all entries from the ini file and the compound file.
	CIniDoc* pDoc = GetDocument ();
	pDoc->DoTimeTest (CIniDoc::TEST_GETALL);
}

void CIniView::OnWriteShorter()
{
	// Make all of the entries in both files one byte shorter.
	CIniDoc* pDoc = GetDocument ();
	pDoc->DoTimeTest (CIniDoc::TEST_WRITE_SHORTER);	
	
}

void CIniView::OnWriteLonger()
{
	// Make all of the entries in both files one byte longer.
	CIniDoc* pDoc = GetDocument ();
	pDoc->DoTimeTest (CIniDoc::TEST_WRITE_LONGER);
}
